package cn.axzo.workflow.core.deletage;

import cn.axzo.maokai.api.client.OrganizationalNodeUserApi;
import cn.axzo.maokai.api.vo.request.FlowTaskAssignerReq;
import cn.axzo.maokai.api.vo.response.FlowTaskAssigner;
import cn.axzo.workflow.common.enums.ApproverSpecifyEnum;
import cn.axzo.workflow.common.model.request.bpmn.task.BpmnTaskDelegateAssigner;
import cn.axzo.workflow.core.deletage.approverscope.ApproverScopeDTO;
import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import lombok.extern.slf4j.Slf4j;
import org.flowable.bpmn.model.UserTask;
import org.flowable.engine.delegate.DelegateExecution;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 基于"岗位"查询审批人
 *
 * @author wangli
 * @since 2023/11/16 11:35
 */
@Slf4j
@Component
public class PositionTaskAssigneeSelector extends AbstractBpmnTaskAssigneeSelector {

    @Autowired
    private OrganizationalNodeUserApi organizationalNodeUserApi;

    @Override
    public boolean support(String param) {
        return ApproverSpecifyEnum.position.getType().equals(param);
    }

    @Override
    protected List<BpmnTaskDelegateAssigner> invokeService(UserTask userTask, DelegateExecution execution,
                                                           ApproverScopeDTO scopeDto) {
        FlowTaskAssignerReq req = FlowTaskAssignerReq.builder()
                .orgScopes(scopeDto.getOrgScopes().stream()
                        .map(e -> BeanUtil.copyProperties(e, FlowTaskAssignerReq.OrgScope.class))
                        .collect(Collectors.toList()))
                .jobCodes(super.getTypes(userTask))
                .build();

        List<FlowTaskAssigner> flowTaskAssigners =
                parseApiResult(() -> organizationalNodeUserApi.listFlowTaskAssigner(req), "通过岗位查询审批人", req);

        if (CollUtil.isEmpty(flowTaskAssigners)) {
            return Collections.emptyList();
        }
        return BeanUtil.copyToList(flowTaskAssigners, BpmnTaskDelegateAssigner.class);
    }
}
